\section{Introduction}

Recently we have witnessed an increase is use of SSO protocols, to ease the use of multiple platforms that require authentication. One example can be the many government services available online that can be accessed at anytime and require one single authentication, or even the many service platforms delivered by private organizations, like Facebook or Google and its plethora of services, accessible with just one account.


The use of SSO protocols is almost necessary, due to the diversity of the average person that require online applications. This huge growth in online services brought many inexperienced users which may find remembering a large number of credentials difficult, or even understand what credential to use given an application. On the other hand, this can be useful even to most expert user: why have one account per application needed when you can simply sign in once and just continue with your work.\\
The protocols that will soon be explained in detailed are the simplest solution to this situation and they have become successful in the recent times because of their key features:
\begin{itemize}
	\item \textit{Decentralization}: they do not require a centralized figure that acts as authentication/authorization provider but anyone who wishes to implement their version can act as provider
	\item \textit{Extensions}: this protocols have been developed with modularity in mind, with the possibility of adding new feature with extensions
	\item \textit{Platform agnostic}: they do not require a specific platform to work, instead they have been developed using API which can be used by both Web applications and Mobile ones
\end{itemize}


These basic foundations were chosen because of their versatility: they made it possible for private companies to use these protocols without relying on third-parties and implement them on any platform they preferred, web or mobile. Most importantly, if a developer for any reason needed a feature which was not available, they could simply add it.

\subsection{Problem statement}
OAuth and OpenID are the leading authentication/authorization protocols available at the moment and they represent a well tested solution to the problem described above. Nonetheless, the implementations of these protocols can be flawed, due to the fact that many of the parameters used are not defined as mandatory and can be omitted if the programmer wishes to(or neglects to). This bring to the table many  problems such as: incorrect generation, incorrect checks or validations for codes or tokens in the authorization/authentication flow.
Furthermore, the issue stated becomes more relevant when we go deeper into the details of these protocols: they use codes and tokens which are described as bearer credentials. This type of credential makes the foundations for many different protocols in many fields of Cyber Security because of the basic idea behind it: the bearer of the token or code, which is everyone in possession of it, is acknowledged as an authenticated and/or authorized user, which means he or she has complete access to any confidential information linked to the account. The approach just described has become successful for both its ease of use and how simple is to implement. The user just provides the required credential and can use the needed web services, but the provider does not check for the real identity of the user.

This issue is in demand of some kind of tool to automate the verification of the right implementation in web apps and this is where this thesis wants to bring some contribution: explain the open source plugin made that tries to find the solution to this significant matter and help developers deliver bug-free products.

\newpage

\subsection{Structure of the thesis}
The thesis is structured in this manner:
\begin{description}
	\item \textbf{Chapter 2} presents the basic terminology for this thesis and the protocols and frameworks used
	\item \textbf{Chapter 3} presents the results of the state of the art search of already available tools on the web
	\item \textbf{Chapter 4} presents the sources used for listing and prioritizing the current best practices and attacks on well-known applications
	\item \textbf{Chapter 5} presents a description of the test cases used for the plugin
	\item \textbf{Chapter 6} presents the plugin's architecture and the checks implemented
	\item \textbf{Chapter 7} presents the results of the analysis made on the most well-known web applications
\end{description}

\newpage